/****************************************************************************
 *
 *  			Copyright 1997 Jasspa
 *
 *  System        : MicroEmacs Jasspa Distribution
 *  Object Name   : $RCSfile$
 *  Revision      : $Revision$
 *  Date          : $Date$
 *  Author        : Steve Philips
 *  Created       : Thu Nov 27 19:17:17 1997
 *  Last Modified : <990706.1007>
 *
 *  Description	
 *       Encapsulate all of the platform definitions into a sigle file
 *
 *  Notes
 *       Macro definitions defined within this file obey the
 *       following rules:-
 * 
 *       _XXXX - Underscore names are tested using
 *               "#if (defined _XXXX)", and are disabled by
 *               using "#undef _XXXX" following the definition
 *               to remove or disable.
 *
 *       XXXX  - Non-underscore names are tested using 
 *               "#if XXXXX". A zero disables the option.
 *               Non-zero (typically 1) enables the option.
 *
 *  History
 *	
 *  $Log$
 *
 ****************************************************************************
 *
 * Copyright (C) 1997 - 1999, JASSPA 
 * 
 * The MicroEmacs Jasspa distribution can be copied and distributed freely for
 * any non-commercial purposes. The MicroEmacs Jasspa Distribution can only be
 * incorporated into commercial software with the expressed permission of
 * JASSPA.
 *  
 ****************************************************************************/
#ifndef __EMAIN_H__
#define __EMAIN_H__

#ifdef _IRIX
#define	meSYSTEM_NAME	"irix"	        /* Identity name of the system	*/
#define	_USG     1			/* UNIX system V		*/
#define _SYSV42  1			/* UNIX system V v4.2		*/
#define _TERMIOS 1			/* Use termios, not termio	*/
#endif

#ifdef _HPUX
#define	meSYSTEM_NAME	"hpux"	        /* Identity name of the system	*/
#define	_USG     1			/* UNIX system V		*/
#endif

#ifdef _UNIXWR1 
#define	meSYSTEM_NAME	"unixwr1"        /* Identity name of the system	*/
#define	_USG     1			/* UNIX system V		*/
#define _SYSV42  1			/* UNIX system V v4.2		*/
#define _TERMIOS 1			/* Use termios, not termio	*/
#endif

/* _SUNOS == Sparc Solaris; _SUNOS_X86 == i86 Solaris */
#if (defined _SUNOS) || (defined _SUNOS_X86)
#define	meSYSTEM_NAME	"sunos"	        /* Identity name of the system	*/
#define	_USG     1			/* UNIX system V		*/
#define _SYSV42  1			/* UNIX system V v4.2		*/
#define _TERMIOS 1			/* Use termios, not termio	*/
#endif

#ifdef _FREEBSD
#define	meSYSTEM_NAME	"freebsd"       /* Identity name of the system	*/
#define	_USG     1			/* UNIX system V		*/
#define _SYSV42  1			/* UNIX system V v4.2		*/
#define _TERMIOS 1			/* Use termios, not termio	*/
#endif

#ifdef _AIX
#define	meSYSTEM_NAME	"aix"           /* Identity name of the system	*/
#define	_USG     1			/* UNIX system V		*/
#define _SYSV42  1			/* UNIX system V v4.2		*/
#define _TERMIOS 1			/* Use termios, not termio	*/
#endif

#ifdef _LINUX
#define	meSYSTEM_NAME	"linux"         /* Identity name of the system	*/
#define	_USG     1			/* UNIX system V		*/
#define _SYSV42  1			/* UNIX system V v4.2		*/
#define _TERMIOS 1			/* Use termios, not termio	*/
#endif

#ifdef _DOS
#define	meSYSTEM_NAME	"dos"		/* Identity name of the system	*/
#define _CTRLZ   1	   /* add a ^Z at end of files under MSDOS only	*/
#define _CTRLM   1	   /* add a ^M at end of lines under MSDOS only	*/
#define _SINGLE_CASE 1     /* Files only have single case                */
#define _DRV_CHAR     ':'  /* drive divide letter, ie C:\dos             */
#define _CONVDIR_CHAR '\\' /* Convert all '\\' to '/' in file names      */
#endif

#ifdef _WIN32s                          /* Win32s                       */
#define _WIN32   1                        /* Use win32                    */
#endif

#ifdef _WIN32
#define	meSYSTEM_NAME	"win32"	/* Identity name of the system	            */
#define _CTRLZ	 1		/* add a ^Z at end of files under MSDOS only*/
#define _CTRLM	 1		/* add a ^M at end of lines under MSDOS only*/
#if (_MSC_VER != 900)
/* MSVC Not version 2 - win32s */
#define	_IPIPES  1		/* platform supports Inc. pipes             */
#define _CLIENTSERVER 1         /* Client server support                    */
#endif
/*#define _URLSUPP  1*/		/* Supports url reading                     */
#define _CLIPBRD 1		/* Inter window clip board supp             */
#define _WINDOW  1		/* Has a window, need resizing & title code */
#define	_INSENSE_CASE 1		/* File names are case insensitive          */
#define _DRAGNDROP    1         /* Drag and drop supported.                 */
#define _DRV_CHAR    ':'	/* drive divide letter, ie C:\dos           */
#define _CONVDIR_CHAR '\\'	/* Convert all '\\' to '/' in file names    */
#define WIN32_LEAN_AND_MEAN
#include        <windows.h>     /* Standard windows API                     */
#undef WIN32_LEAN_AND_MEAN
#ifdef _DRAGNDROP
#include <shellapi.h>           /* Drag and drop API                        */
#endif
#endif

#if (defined _V7) || (defined _BSD) || (defined _USG)
#define	_UNIX	  1
#define _TCAP     1		/* Use TERMCAP                  */
#define _TCAPFONT 1		/* Use TERMCAP fonts to color   */
#define _XTERM    1		/* Use Xlib                     */
#define	_IPIPES   1		/* platform supports Inc. pipes */
#define _CLIENTSERVER 1         /* Client server support        */
#define _URLSUPP  1		/* Supports url reading         */
#ifdef _XTERM
#define _CLIPBRD  1		/* Inter window clip board supp */
#define _WINDOW   1		/* Has a window, need resizing & title code */
#include <X11/Intrinsic.h>	/* Intrinsics Definitions       */
#include <X11/StringDefs.h>	/* Standard Name-String definitions*/
#include <X11/Xutil.h>
#endif
#include <signal.h>
#include <unistd.h>
#endif

/* These next 2 defines are platform specific, but as all supported 
 * platforms use these and all future ones should I've put them here
 * for now.
 */
#define	_STDARG	1	/* Use <stdarg.h> in defintions			*/
#define	_ANSI_C	1	/* ANSI_C to be used				*/

/* MicroEmacs Configuration options */
#define	CFENCE	1	/* fench matching in CMODE			*/
#define	TYPEAH	1	/* type ahead causes update to be skipped	*/
#define DEBUGM	1	/* Global SPELL mode triggers macro debugging	*/
#define	TIMSTMP	1	/* Enable time stamping of files on write.	*/

#define	COLOR	1	/* color commands and windows			*/
#define HILIGHT 1	/* color hilighting 				*/

#define	ISRCH	1	/* Incremental searches like ITS EMACS		*/
#define	WORDPRO	1	/* Advanced word processing features		*/
#define APROP	1	/* Add code for Apropos command 		*/
#define CRYPT	1	/* file encryption enabled?			*/
#define MAGIC	1	/* include regular expression matching? 	*/
#define	ABREV	1	/* Abreviated files				*/
#define	FLNEXT	1	/* include the file next buffer stuff           */
#define	DORCS	1	/* do rcs check ins and outs                    */
#define	MOUSE	1	/* do mouse pointer stuff                       */
#define	LCLBIND	1	/* do local key binding (buffer)                */
#define	PRINT	1	/* do printing of buffers and regions           */
#define	SPELL	1	/* do spelling of words and buffers             */
#define	MEUNDO	1	/* undo capability                              */
#define	URLAWAR	1	/* understands url file names (may not read em) */
#define	NARROW	1	/* enable narrowing functionality               */
#define REGSTRY 1       /* enable registry functionality                */

/* One may think that this should be platform dependant, BUT time and
 * experience has shown that it is best to always use a '/' in the body
 * of MicroEmacs (simplifies everything) and convert to or from the
 * system DIR Cchar if required. No system yet needs this but
 * as some need to check and convert to a '/' they define a CONVDIR_CHAR
 */
#define DIR_CHAR  '/'   /* directory divide char, ie /bin/ */

#ifdef _ANSI_C
#define	APRAM(x)	x
#else
#define	APRAM(x)	()
#endif

/* Standard microemacs includes */
#include <stdio.h>      /* Always need this              */
#include <stdlib.h>     /* Usually need this             */
#include <errno.h>      /* Need errno and sys_errlist    */
#if (defined _HPUX) || (defined _SUNOS) || (defined _AIX)
extern char *sys_errlist[];
#endif

#include "emode.h"      /* Mode enum, type & var defs    */
#include "estruct.h"    /* Type structure definitions    */
#include "edef.h"       /* Global variable definitions   */
#include "eterm.h"      /* platform terminal definitions */
#include "eextrn.h"	/* External function defintions  */

#endif /* __EMAIN_H__ */

