/*
 *	SCCS:		%W%		%G%		%U%
 *
 *	Last Modified :	<020699.1622>
 *
 *	EVAR.H: Environment and user variable definitions
 *		for MicroEMACS
 *
 *		written 1986 by Daniel Lawrence
 *
 * Jon Green	17-05-91
 * Added suffix modes so that the suffix defintions may be defined in the 
 * start up file.
 *
 ****************************************************************************
 * 
 * Modifications to the original file by Jasspa. 
 * 
 * Copyright (C) 1988 - 1999, JASSPA 
 * The MicroEmacs Jasspa distribution can be copied and distributed freely for
 * any non-commercial purposes. The MicroEmacs Jasspa Distribution can only be
 * incorporated into commercial software with the expressed permission of
 * JASSPA.
 * 
 ****************************************************************************/

#define	DEFVAR(s,v)	v,
#define	DEFFUN(v,s,t)
#define	DEFDER(v,s,t)

enum	{
#include	"evar.def"
    NEVARS			/* Number of variables */
} ;	
#undef	DEFVAR
#undef	DEFFUN
#undef	DEFDER


#define	DEFVAR(s,v)	/* NULL */
#define	DEFFUN(v,s,t)	v,
#define	DEFDER(v,s,t)

enum	{
#include	"evar.def"
    NFUNCS			/* Number of functions */
} ;	
#undef	DEFVAR
#undef	DEFFUN
#undef	DEFDER


#define	DEFVAR(s,v)	/* NULL */
#define	DEFFUN(v,s,t)
#define	DEFDER(v,s,t)   v,

enum	{
#include	"evar.def"
    NDERIV			/* Number of derivatives */
} ;	
#undef	DEFVAR
#undef	DEFFUN
#undef	DEFDER


#ifdef __EXECC


/**	list of recognized environment variables	*/

#define	DEFVAR(s,v)	s,
#define	DEFFUN(v,s,t)
#define	DEFDER(v,s,t)

char *envars[] =
{
#include	"evar.def"
    0
};

#undef	DEFVAR
#undef	DEFFUN
#undef	DEFDER


/**	list of recognized user function names	*/

#define	DEFVAR(s,v)	/* NULL */
#define	DEFFUN(v,s,t)	s,
#define	DEFDER(v,s,t)

char *funcNames[] =
{
#include	"evar.def"
};

#undef	DEFVAR
#undef	DEFFUN
#undef	DEFDER

/**	list of recognized user function types	*/

#define	DEFVAR(s,v)	/* NULL */
#define	DEFFUN(v,s,t)	t,
#define	DEFDER(v,s,t)

char funcTypes[] =
{
#include	"evar.def"
};

#undef	DEFVAR
#undef	DEFFUN
#undef	DEFDER

/**	list of recognized user directives	*/

#define	DEFVAR(s,v)	/* NULL */
#define	DEFFUN(v,s,t)
#define	DEFDER(v,s,t)	s,

char *derNames[] =
{
#include	"evar.def"
};

#undef	DEFVAR
#undef	DEFFUN
#undef	DEFDER

/**	list of user directive types	*/

#define	DEFVAR(s,v)	/* NULL */
#define	DEFFUN(v,s,t)
#define	DEFDER(v,s,t)	t,

unsigned char derTypes[] =
{
#include	"evar.def"
};

#undef	DEFVAR
#undef	DEFFUN
#undef	DEFDER


#endif /* maindef */
