/*
 *	SCCS:		%W%		%G%		%U%
 *
 *	Last Modified :	<990716.1454>
 *
 *	INPUT:	Various input routines for MicroEMACS 3.7
 *		written by Daniel Lawrence
 *		5/9/86
 *
 *	BUG:	mlreply() responds to backChar as back word. Backspace 
 *		does not delete previous character. Fix 05/11/90 JDG. 
 *
 *	BUG	mldisp() Core dumps if the search/replace string exceeds 
 *		50 characters. The 'space' variable has to be set up to
 *		PROMSIZ - 1 to allow for the '\0'. Hence changed variable
 *		to be -1 to stop it core dumping.
 *		Fix 16/07/91 JDG. - It's taken me 6 months to find this
 *		bastard since SDB on core gave me a differnt address !!!
 *
 **************************************************************************
 * 
 * Modifications to the original file by Jasspa. 
 * 
 * Copyright (C) 1988 - 1999, JASSPA 
 * The MicroEmacs Jasspa distribution can be copied and distributed freely for
 * any non-commercial purposes. The MicroEmacs Jasspa Distribution can only be
 * incorporated into commercial software with the expressed permission of
 * JASSPA.
 * 
 ****************************************************************************/

#define	__INPUTC			/* Define the name of the file */

#include "emain.h"
#include "efunc.h"
#include "evar.h"
#include "eskeys.h"

/*
 * Ask a yes or no question in the message line. Return either TRUE, FALSE, or
 * ABORT. The ABORT status is returned if the user bumps out of the question
 * with a ^G. Used any time a confirmation is required.
 */
int
mlCharReply(char *prompt, int mask, char *validList, char *helpStr)
{
    int  inpType=0, cc ;
    char buff[MAXBUF], *ss=NULL ;
    char *pp=prompt ;
    
    for(;;)
    {
        if((clexec == FALSE) || inpType ||
           ((execstr=token((ss=execstr),buff)),(strncmp("@mn",buff,3) == 0)))
        {
            /* if @mna (get all input from user) then rewind the execstr */
            if((ss != NULL) && (buff[3] == 'a'))
                execstr = ss ;
            if((kbdmode != PLAY) || (kbdoff >= kbdlen))
            {
                /* We are going to get a key of the user!! */
                if(mask & mlCR_QUIT_ON_USER)
                    return -2 ;
                if(mask & mlCR_UPDATE_ON_USER)
                    update(TRUE) ;
                
                if(mlStatus & MLSTATUS_POSOSD)
                {
                    mlStatus = MLSTATUS_POSOSD ;
                    mlResetCursor() ;
                }
                else
                {
                    /* switch off the status cause we are replacing it */
                    mlStatus = 0 ;
                    mlwrite((mask & mlCR_CURSOR_IN_MAIN) ? 0:MWCURSOR,pp) ;
                    mlwrite(((mask & mlCR_CURSOR_IN_MAIN) ? 0:MWCURSOR)|MWSPEC,pp) ;
                    pp = prompt ;
                    /* switch on the status so we save it */
                    mlStatus = (mask & mlCR_CURSOR_IN_MAIN) ? MLSTATUS_KEEP:(MLSTATUS_KEEP|MLSTATUS_POSML) ;
                    inpType = 2 ;
                }
            }
            cc = tgetc() ;
            mlStatus &= ~(MLSTATUS_KEEP|MLSTATUS_RESTORE|MLSTATUS_POSML) ;
            if(cc == 0x07)
                return -1 ;
        }
        else
        {
            /* evaluate it */
            char *res = getval(buff) ;
            if(res == abortm)
                return -1 ;
            cc = *((unsigned char *) res) ;
        }
        
        if((mask & mlCR_QUOTE_CHAR) &&
           ((cc = quoteKeyToChar((unsigned short) cc)) < 0))
        {
            if(validList == NULL)
                return -1 ;
        }
        else
        {
            if(mask & mlCR_LOWER_CASE)
                cc = toLower(cc) ;
            
            if((cc == '?') && (helpStr != NULL))
                pp = helpStr ;
            else if((cc != '\0') &&
                    (!(mask & mlCR_ALPHANUM_CHAR) || isAlphaNum(cc)) &&
                    ((validList == NULL) || (strchr(validList,cc) != NULL)))
            {
                if (inpType == 2)
                {
                    cmdstr((unsigned short) cc,buff) ;
                    mlwrite(MWCURSOR,"%s%s",prompt,buff) ;
                }
                return cc ;
            }
        }
        inpType = 1 ;
    }
}

int
mlyesno(char *prompt)
{
    char buf[MAXBUF] ;	/* prompt to user */
    int  ret ;
    
    /* build and prompt the user */
    strcpy(buf,prompt) ;
    strcat(buf," [y/n]? ") ;

    ret = mlCharReply(buf,mlCR_LOWER_CASE,"yn",NULL) ;
    
    if(ret == -1)
        return ctrlg(FALSE,1) ;
    else if(ret == 'n')
        return FALSE ;
    return TRUE ;
}

/*
 * These are very simple character inserting, character deleting, move
 * over or erase spaces forwards or backwards routines. They are used
 * by the mlreply routine to edit the command line.
 */

int
cins(char c, char *buf, int *pos, int *len, int max)
{
    /*
     * Insert a character "c" into the buffer pointed to by "buf" at
     * position pos (which we update), if the length len (which we
     * also update) is less than the maximum length "max".
     *
     * Return:	TRUE	if the character will fit
     *		FALSE	otherwise
     */
    *len = strlen(buf);
    if(*len + 1 >= max)
        return FALSE ;
    
    if(*pos == *len)
    {
        /* The character goes on the end of the buffer. */
        buf[*pos] = c;
        ++*len;
        ++*pos;
        buf[*pos] = '\0';
    }
    else
    {
        /* The character goes in the middle of the buffer. */
        char	temp[MAXBUF] ;
        
        /* save the bit after pos */
        strcpy(temp, buf+(*pos));

        /* insert the character */
        buf[*pos] = c;
        ++*pos;
    
        /* glue the two halves together again */
        strcpy(buf+(*pos), temp);
        
        /* update the length */
        ++*len;
    }
    return TRUE ;
}

void
cdel(char *buf, int pos, int *len)
{
    /*
     * Delete the character at position 'pos' in the buffer, update len.
     */
    strcpy(&buf[pos], &buf[pos + 1]);
    buf[--*len] = '\0';
}

#define	ERASE	(-1)		/* erase whatever we move over	*/
#define	LEAVE	1		/* leave whatever we move over	*/

/* buf		pointer to buffer 		*/
/* pos		position in above buffer	*/
/* len		length of buffer (ie no. of chars in it) */
/* state	either ERASE or LEAVE		*/
void
fspace(char *buf, int *pos, int *len, int state)
{
    /*
     * Move over or erase spaces in the buffer (depending on the value
     * of "state") pointed to by "buf", after the current cursor position,
     * given by "pos", updating the length (ie the number of characters
     * in the buffer).
     */
    register char	c;
    
    for(;;)
    {
        if(*pos >= *len)
            return;
        
        if((c = buf[*pos]) != ' ' && c!= '\t' && c != DIR_CHAR)
            return;
        
        if(state == ERASE)
            cdel(buf, *pos, len);
        else
            ++*pos;
    }
}

/* buf		pointer to buffer 		*/
/* pos		position in above buffer	*/
/* len		length of buffer (ie no. of chars in it) */
/* state	either ERASE or LEAVE		*/
void
bspace(char *buf, int *pos, int *len, int state)
{
    /*
     * Identical to fspace() except that we go backwards instead of
     * forwards.
     */
    register char	c;
    
    for(;;)
    {
        if(*pos == 0)
            return;
        
        if((c = buf[*pos - 1]) != ' ' && c != '\t' && c != DIR_CHAR)
            return;
        
        if(state == ERASE)
            cdel(buf, *pos - 1, len);
        
        --*pos;
    }
}

/* buf		pointer to buffer 		*/
/* pos		position in above buffer	*/
/* len		length of buffer (ie no. of chars in it) */
/* state	either ERASE or LEAVE		*/
void
fword(char *buf, int *pos, int *len, int state)
{
    /*
     * Move forward over a "word", erasing it if "state" is ERASE.
     * The defintion of "word" is very rudimentary. It is considered
     * to be delimited by a space or by the dir char "/" character.
     */
    register char	c;
    
    for(;;)
    {
        if(*pos >= *len)
            return ;
        
        if((c = buf[*pos]) == ' ' || c == '\t' || c == DIR_CHAR)
            return;
        
        if(state == ERASE)
            cdel(buf, *pos, len);
        else
            ++*pos;
    }
}

/* buf		pointer to buffer 		*/
/* pos		position in above buffer	*/
/* len		length of buffer (ie no. of chars in it) */
/* state	either ERASE or LEAVE		*/
void
bword(char *buf, int *pos, int *len, int state)
{
    /*
     * As for fword() but go backwards to the start, instead of forwards.
     */
    register char c;
    
    for(;;)
    {
        if(*pos == 0)
            return;
        
        if((c = buf[*pos - 1]) == ' ' || c == '\t' || c == DIR_CHAR)
            return;
        
        if(state == ERASE)
            cdel(buf, *pos - 1, len);
        
        --*pos;
    }
}

/*
 * mldisp() - expand control characters in "prompt" and "buf" (ie \t -> <TAB>,
 * \n -> <NL> etc etc). The third argument, "cpos" causes mldisp() to return
 * the column position of the "cpos" character in the "buf" string, ie if
 * mldisp is called as:
 *
 *        mldisp("hello", "\n\nthere", 3);
 *
 * Then mldisp will return:
 *
 *        5 + 4 + 4 + 1 = 10
 *        ^   ^   ^   ^
 *        |   |   |   |
 *    lenght of   |   |   length of "t"
 *       prompt   |   |   ^
 *      "hello"   lenght  |
 *            of <NL> |
 *            ^        |
 *            |-------|
 *            |
 *            3 characters into "buf"
 *
 * If "cpos" is < 0 then the the length of the expanded prompt + buf
 * combination, or term.t_ncol is returned (the routine displays only
 * term.t_ncol characters of the expanded buffer.
 * Added continue string which is printed after buf.
 */

#define    RESTSIZ        200    /* length of buf expand buffer      */

/* prompt         prompt to be displayed      */
/* buf            buffer to expand controls from */
/* cont           continuing str to be displayed */
/* cpos           offset into "buf"          */
/* expChr         0=dont expand unprintables, use ?, 1=expand ?'s */
void
mlDisp(char *prompt, char *buf, char *cont, int cpos)
{
    int    len ;               /* offset into current buffer   */
    char   expbuf[RESTSIZ+1];    /* expanded buf                 */
    int    start, col, maxCol ;
    int    promsiz ;
    
    col = -1 ;
    len = expandexp(-1,(unsigned char *) buf,RESTSIZ,0,expbuf,cpos,&col,0) ;
    if(col < 0)
        col = len ;
    if(cont != NULL)
    {
        strncpy(expbuf+len,cont,RESTSIZ-len);
        expbuf[RESTSIZ] = '\0' ;
        len += strlen(expbuf+len) ;
    }
    /* switch off the status cause we are replacing it */
    mlStatus = 0 ;
    maxCol = TTncol ;
    promsiz = strlen(prompt) ;
    col += promsiz ;
    len += promsiz ;
    /*
     * Having expanded it, display it.
     *
     * "ret" which is the actual column number of the "cpos" character
     * is used as an indication of how to display the line. If it is
     * too long for the terminal to display then:
     *    if "ret" is between 0 and max-column-number
     *    then
     *        display with $ in right hand column
     *    else
     *        display with $ after prompt
     *
     * Be careful about putting characters in the lower left hand corner
     * of the screen as this may cause scrolling on some terminals.
     */
    if(col > maxCol - 1)
    {
        int div = maxCol >> 1 ;
        
        start = (((col - (div >> 1)) / div) * div) ;
        len -= start ;
        col -= start-1 ;
        maxCol-- ;
    }
    else
        start = 0 ;
    if(len > maxCol)
    {
        expbuf[start+maxCol-promsiz-1] = '$';
        expbuf[start+maxCol-promsiz] = '\0';
    }
    mlCol = col ;
    if(start >= promsiz)
        mlwrite(MWUSEMLCOL|MWCURSOR,"%s%s",(start) ? "$":"",expbuf+start-promsiz) ;
    else
        mlwrite(MWUSEMLCOL|MWCURSOR,"%s%s%s",(start) ? "$":"",prompt+start,expbuf) ;
    
    /* switch on the status so we save it */
    mlStatus = MLSTATUS_KEEP|MLSTATUS_POSML ;
}



/*    tgetc:    Get a key from the terminal driver, resolve any keyboard
 *              macro action
 */

unsigned short
tgetc(void)
{
    unsigned short cc ;    /* fetched character */

    /* if we are playing a keyboard macro back, */
    if (kbdmode == PLAY)
    {
        if(TTbreakTest(0))
            ctrlg(FALSE,1) ;
kbd_rep:
        /* if there is some left... */
        if(kbdoff < kbdlen)
        {
            cc = (unsigned short) kbdptr[kbdoff++] ;
            if(cc == 0xff)
            {
                cc = kbdptr[kbdoff++] ;
                if(cc == 0x02)
                {
                    unsigned char dd ;    /* fetched character */
                    cc = ((unsigned short) kbdptr[kbdoff++]) << 8 ;
                    if(((dd = kbdptr[kbdoff++]) != 0xff) ||
                       ((dd = kbdptr[kbdoff++]) != 0x01))
                        cc |= dd ;
                }
                else if(cc == 0x01)
                    cc = 0 ;
            }                    
            return cc ;
        }
        /* at the end of last repitition? */
        if (--kbdrep > 0)
        {
            /* reset the macro to the begining for the next rep */
            kbdoff = 0 ;
            goto kbd_rep ;
        }
        kbdmode = STOP;
#if MEUNDO
        undoContFlag++ ;
#endif
        
        /* force a screen update after all is done */
        update(FALSE);
    }

    if(kbdmode == RECORD)
    {
        /* get and save a key */
        do {
            /* fetch a character from the terminal driver */
            cc = TTgetc();
            /* if this is a mouse key, ignored while recording a macro - get another */
        } while(((cc & (ME_SPECIAL|0x00ff)) >= (ME_SPECIAL|SKEY_mouse_drop_1))  &&
                ((cc & (ME_SPECIAL|0x00ff)) <= (ME_SPECIAL|SKEY_mouse_time_3))) ;
        /* Each 'key' could take 5 chars to store - if we haven't got room
         * stop so we don't overrun the buffer */
        if(kbdlen > NKBDM - 5)
        {
            kbdmode = STOP;
            TTbell();
        }
        else
        {
            unsigned char dd ;
            /* must store 0xaabb as ff,2,aa,bb
             * also must store 0x00ff as ff,ff & 0x0000 as 0xff01
             * Also 0x??00 stored as ff,2,??,ff,01
             */
            if(cc > 0xff)
            {
                kbdptr[kbdlen++] = 0xff ;
                kbdptr[kbdlen++] = 2 ;
                kbdptr[kbdlen++] = cc >> 8 ;
            }
            dd = (cc & 0xff) ;
            if(dd == 0xff)
            {
                kbdptr[kbdlen++] = 0xff ;
                kbdptr[kbdlen++] = 0xff ;
            }
            else if(dd == 0x0)
            {
                kbdptr[kbdlen++] = 0xff ;
                kbdptr[kbdlen++] = 0x01 ;
            }
            else
                kbdptr[kbdlen++] = dd ;
        }
    }
    else
        cc = TTgetc();

    /* and finally give the char back */
    return cc ;
}


int
getprefixchar(int f, int n, int ctlc, int silent)
{
    char buf[20] ;
    int c ;

    if(!silent)
    {
        buf[cmdchar((unsigned short) ctlc,buf)] = '\0' ;
        if(f==TRUE)
            mlwrite(MWCURSOR,"Arg %d: %s", n, buf);
        else
            mlwrite(MWCURSOR,"%s", buf);
    }
    c = tgetc();
    c = toLower(c) ;
    return c ;
}

/*    GETCMD:    Get a command from the keyboard. Process all applicable
        prefix keys
 */
unsigned short
getkeycmd(int f, int n, int silent)
{
    unsigned short cc ;        /* fetched keystroke */
    int ii ;
    
    silent |= (kbdmode == PLAY) ;

    if(f && !silent)
        mlwrite(MWCURSOR,"Arg %d:",n);

    /* get initial character */
    cc = tgetc();
    
    /* If we are in idle mode then disable now */
    if (kbdmode == KBD_IDLE)            /* In the idle state */
        kbdmode = STOP;                 /* Restore old state */

    /* process prefixes */
    ii = ME_PREFIX_NUM+1 ;
    while(--ii > 0)
        if(cc == prefixc[ii])
        {
            cc = ((ii << ME_PREFIX_BIT) | getprefixchar(f,n,cc,silent)) ;
            break ;
        }

    /* return the key */
    thiskey = cc ;
    return cc ;
}

static Fintssi curCmpIFunc ;
static Fintss  curCmpFunc ;

int
getFirstLastPos(int noStr,char **strs, char *str, int option,
                int *fstPos, int *lstPos)
{
    register int nn ;
    
    if((nn = strlen(str)) == 0)
    {
        *fstPos = 0 ;
        *lstPos = noStr - 1 ;
        if(noStr <= 0)
            return 0 ;
    }
    else
    {
        register int ii, rr ;
        
        for(ii=0 ; ii<noStr ; ii++)
            if(!(rr = curCmpIFunc(str,strs[ii],nn)))
                break ;
            else if(rr < 0)
                return 0 ;
        
        if(ii == noStr)
            return 0 ;
        
        *fstPos = ii ;
        for(++ii ; ii<noStr ; ii++)
            if(curCmpIFunc(str,strs[ii],nn))
                break ;
        *lstPos = ii - 1 ;
    }
    if((option & MLFILE) && (fileIgnore != NULL))
    {
        /* try to eat away at the number of possible completions
         * until there is only one. If successful the return as
         * just one. Can remove fileIngore type files which are 
         * usually . .. and backup files (*~) etc.
         */
        register int   ff, ll, ii=1, len, fil ;
        register char *ss, *fi, cc ;
        ff = *fstPos ;
        ll = *lstPos ;
        
        while((ff <= ll) && (ii >= 0))
        {
            if(ii)
                ss = strs[ll] ;
            else
                ss = strs[ff] ;
            len = strlen(ss) ;
            fi = fileIgnore ;
            for(;;)
            {
                fil=1 ;
                while(((cc=fi[fil]) != ' ') && (cc != '\0'))
                    fil++ ;
                if((fil <= len) &&
                   !curCmpIFunc(ss+len-fil,fi,fil))
                {
                    if(ii)
                        ll-- ;
                    else
                        ff++ ;
                    break ;
                }
                fi += fil ;
                if(*fi++ == '\0')
                {
                    ii-- ;
                    break ;
                }
            }
        }
        if(ff == ll)
            *fstPos = *lstPos = ff ;
    }
    return 1 ;
}

int
createBuffList(char ***listPtr, int noHidden)
{
    register BUFFER *bp = bheadp ;    /* index buffer pointer    */
    register int     i, n ;
    register char  **list ;

    n = 0 ;
    while(bp != NULL)
    {
        if(!noHidden || !meModeTest(bp->b_mode,MDHIDE))
            n++;
        bp = bp->b_bufp ;
    }
    if((list = (char **) meMalloc(sizeof(char *) * n)) == NULL)
        return 0 ;
    bp = bheadp ;
    for(i=0 ; i<n ; )
    {
        if(!noHidden || !meModeTest(bp->b_mode,MDHIDE))
            list[i++] = bp->b_bname ;
        bp = bp->b_bufp ;
    }
    *listPtr = list ;
    return i ;
}
    
int
createVarList(char ***listPtr)
{
    meVARIABLE *vptr;     	/* User variable pointer */
    int     ii, nn ;
    char  **list ;

    nn = NEVARS + usrVarList.count + curbp->varList.count ;
    
    if((list = (char **) meMalloc(sizeof(char *) * nn)) == NULL)
        return 0 ;
    *listPtr = list ;
    
    for(ii=0 ; ii<NEVARS; ii++)
    {
        if((list[ii] = (char *) meMalloc(strlen(envars[ii])+2)) == NULL)
            return 0 ;
        list[ii][0] = '$' ;
        strcpy(list[ii]+1,envars[ii]) ;
    }
    for(vptr=usrVarList.head ; vptr != NULL ; vptr = vptr->next,ii++)
    {
        if((list[ii] = (char *) meMalloc(strlen(vptr->name)+2)) == NULL)
            return 0 ;
        list[ii][0] = '%' ;
        strcpy(list[ii]+1,vptr->name) ;
    }
    for(vptr=curbp->varList.head ; vptr != NULL ; vptr = vptr->next,ii++)
    {
        if((list[ii] = (char *) meMalloc(strlen(vptr->name)+2)) == NULL)
            return 0 ;
        list[ii][0] = ':' ;
        strcpy(list[ii]+1,vptr->name) ;
    }
    return ii ;
}
    
int
createCommList(char ***listPtr, int noHidden)
{
    meCMD *cmd ;
    register int ii ;
    register char **list ;
    
    if((list = (char **) meMalloc(sizeof(char *) * (cmdTableSize))) == NULL)
        return 0 ;
    ii = 0 ;
    cmd = cmdHead ;
    while(cmd != NULL)
    {
        if(!noHidden || (cmd->id < CK_MAX) ||
           !(((meMACRO *) cmd)->hlp->l_flag & MACHIDE))
            list[ii++] = cmd->name ;
        cmd = cmd->anext ;
    }
    *listPtr = list ;
    return ii ;
}


char oldUseMlBinds ;
char **mlgsStrList ;
int    mlgsStrListSize ;
static WINDOW *mlgsOldCwp=NULL ;
static int     mlgsSingWind=0 ;
static int     mlgsCursorState=0 ;
static char   *mlgsStoreBuf=NULL ;

void
mlfreeList(int option, int noStrs, char **strList)
{
    mlStatus = MLSTATUS_CLEAR ;
    useMlBinds = oldUseMlBinds ;
    if(mlgsStoreBuf != NULL)
    {
        meFree(mlgsStoreBuf) ;
        mlgsStoreBuf = NULL ;
    }
    if(strList != NULL)
    {
        if(option & MLVARBL)
            freeFileList(noStrs,strList) ;
        else if(option & (MLBUFFER|MLCOMMAND))
            meFree(strList) ;
    }
    if(mlgsOldCwp != NULL)
    {
        BUFFER *bp=curbp ;
        if(mlgsSingWind)
            delwind(FALSE,FALSE) ;
        else
        {
            BUFFER *rbp=NULL, *tbp=bheadp ;
            while(tbp != NULL)
            {
                if((tbp != bp) && ((rbp == NULL) || (rbp->histNo < tbp->histNo)))
                    rbp = tbp ;
                tbp = tbp->b_bufp ;
            }
            swbuffer(curwp,rbp) ;
            makeCurWind(mlgsOldCwp) ;
        }
        zotbuf(bp,1) ;
        mlgsOldCwp = NULL ;
    }
    if(mlgsCursorState < 0)
        showCursor(TRUE,mlgsCursorState) ;
}

int
mlHandleMouse(char *inpBuf, int inpBufSz, int compOff)
{
    int row, col ;
    
    if((mlgsOldCwp != NULL) &&
       ((row=mouse_Y-curwp->firstRow) >= 0) && (row < curwp->numRows-1) &&
       ((col=mouse_X-curwp->firstCol) >= 0) && (col < curwp->numCols))
    {
        if (col >= curwp->numTxtCols)
        {
            /* only do scroll bar if on pick and bars are enabled */
            if((inpBuf == NULL) && (curwp->w_mode & WMSCROL))
            {
                int ii ;
                for (ii = 0; ii <= (WCVSBML-WCVSBSPLIT); ii++)
                    if (mouse_Y < curwp->w_sbpos[ii])
                        break;
                if(ii == (WCVSBUP-WCVSBSPLIT))
                    scrollUp(1,1) ;
                else if(ii == (WCVSBUSHAFT-WCVSBSPLIT))
                    scrollUp(0,1) ;
                else if(ii == (WCVSBDOWN-WCVSBSPLIT))
                    scrollDown(1,1) ;
                else if(ii == (WCVSBDSHAFT-WCVSBSPLIT))
                    scrollDown(0,1) ;
                update(TRUE) ;
            }
        }
        else
        {
            LINE *lp ;
            int ii, jj, lineNo ;
            
            row += curwp->topLineNo ;
            lineNo = row ;
            lp = curbp->b_linep->l_fp ;
            while(--row >= 0)
                lp = lforw(lp) ;
            if((lp->l_flag & LNNEOL) && (col >= curwp->w_marko))
                ii = curwp->w_marko ;
            else
                ii = 0 ;
            if((ii == 0) && (lp->l_flag & LNNEOL))
            {
                jj = 1 ;
                while((lgetc(lp,jj) != ' ') || (lgetc(lp,jj+1) != ' '))
                    jj++ ;
            }
            else
                jj = llength(lp) ;
            if(jj > col)
            {
                curwp->w_dotp = lp ;
                curwp->w_doto = ii ;
                curwp->line_no = lineNo ;
                setShowRegion(curbp,lineNo,ii,lineNo,jj) ;
                curwp->w_flag |= WFMOVEL|WFSELHIL ;
                if(inpBuf != NULL)
                {
                    if((jj -= ii) >= (inpBufSz-compOff))
                        jj = inpBufSz-compOff-1 ;
                    /* if we already have this, assume the user has double clicked
                     * to 'select', so return 2 to exit */
                    if((inpBuf[compOff+jj] == '\0') && 
                       !strncmp(inpBuf+compOff,(char *) ltext(lp)+ii,jj))
                        return 2 ;
                    strncpy(inpBuf+compOff,(char *) ltext(lp)+ii,jj) ;
                    inpBuf[compOff+jj] = '\0' ;
                }
                update(TRUE) ;
                return 1 ;
            }
        }
    }
    return 0 ;
}

char *compSole     = " [Sole completion]" ;
char *compNoMch    = " [No match]" ;
char *compNoExp    = " [No expansion]" ;
char *compFailComp = " [Failed to create]" ;

#define mlgsDisp(prom,buf,contstr,ipos) \
((mlStatus & MLSTATUS_POSOSD) ? osdDisp(buf,contstr,ipos):mlDisp(prom,buf,contstr,ipos))

/* prompt - prompt associated with what we're typing         */
/* option - bit field which modifies our behaviour slightly  */
/* defnum - the default no. in history (0 = no default)      */
/* buf    - where it all goes at the end of the day          */
/* nbuf   - amount of space in buffer                        */
int
mlgetstring(char *prompt, int option, int defnum, char *buf, int nbuf)
{
    register int cc ;
    int     ii ;
    int     ipos ;                      /* input position in buffer */
    int     ilen ;                      /* number of chars in buffer */
    int     cont_flag ;                 /* Continue flag */
    char  **history ;
    unsigned char onHist, numHist, *numPtr ;
    char   *defaultStr ;
    char    prom[MAXBUF] ;
    char    ch, **strList ;
    int     gotPos=1, fstPos, lstPos, curPos, noStrs ;
    int     changed=1, compOff=0 ;
    char   *contstr=NULL ;
    
    if((mlgsStoreBuf = (char *) meMalloc(nbuf)) == NULL)
       return ABORT ;

    mlerase(0);            /* Blank line to force update */

    if(option & MLINSENSCASE)
    {
        curCmpFunc  = icstrdif ;
        curCmpIFunc = icstrncmp ;
    }
    else
    {
        curCmpFunc  = strcmp ;
        curCmpIFunc = strncmp ;
    }
    numHist = setupHistory(option, &numPtr, &history) ;
    if(option & MLBUFFER)
        noStrs = createBuffList(&strList,1) ;
    else if(option & MLVARBL)
        noStrs = createVarList(&strList) ;
    else if(option & MLCOMMAND)
        noStrs = createCommList(&strList,1) ;
    else if(option & MLUSER)
    {
        strList = mlgsStrList ;
        noStrs = mlgsStrListSize ;
    }
    else
    {
        strList = NULL ;
        noStrs = 0 ;
    }
    if(strList != NULL)
        sortStrings(noStrs,strList,0,curCmpFunc) ;

    if(option & MLNOHIST)
        onHist = ~0 ;
    else
        onHist = numHist+1 ;
    strcpy(prom,prompt) ;
    ii = strlen(prom) ;
    if((defnum > 0) && (defnum <= numHist))
    {
        defaultStr = history[defnum-1] ;
        strncpy(prom+ii," (default [",11) ;
        ii = expandexp(-1,(unsigned char *) defaultStr,MAXBUF-5,ii+11,prom,-1,NULL,0) ;
        strcpy(prom+ii,"]): ") ;
    }
    else
    {
        defaultStr = NULL ;
        strcpy(prom+ii,": ") ;
    }

    if(option & MLNORESET)
    {
        ilen = strlen(buf) ;
        if(mlStatus & MLSTATUS_OSDPOS)
        {
            char *s1, *s2 ;
            s1 = buf ;
            while((--osdRow >= 0) && ((s2 = strchr(s1,meNLCHAR)) != NULL))
                s1 = s2+1 ;
            if(osdRow >= 0)
                ipos = ilen ;
            else
            {
                ipos = (int) s1 - (int) buf + osdCol ;
                if(ipos > ilen)
                    ipos = ilen ;
                if(((s2 = strchr(s1,meNLCHAR)) != NULL) &&
                    (((int) s2 - (int) buf) < ipos))
                    ipos = (int) s2 - (int) buf ;
            }
        }
        else
            ipos = ilen ;
    }
    else
    {
        ipos = ilen = 0 ;
        buf[0] = '\0' ;
    }
    oldUseMlBinds = useMlBinds ;
    useMlBinds = 1 ;
    if((mlgsCursorState=cursorState) < 0)
        showCursor(FALSE,1) ;
    for (cont_flag = 1; cont_flag != 0;)
    {
        mlgsDisp(prom, buf, contstr, ipos) ;
        contstr = NULL ;

        /*
        ** mlfirst  may be set by meShell. If both are unset, get a 
        ** character from the user. 
        */

        if(mlfirst != -1)
        {
            cc = mlfirst ;
            mlfirst = -1;
        }
        else
            cc = getkeycmd (FALSE, 0, 1);
        
        /* is it the mouse? only check for unmodified button events */
        if(cc == (ME_SPECIAL|SKEY_mouse_pick_1))
        {
            if(mlStatus & MLSTATUS_POSOSD)
            {
                if(osdMouseContextChange(1))
                    break ;
            }
            else
                mlHandleMouse(NULL,0,0) ;
        }
        else if(cc == (ME_SPECIAL|SKEY_mouse_drop_1))
        {
            if(!(mlStatus & MLSTATUS_POSOSD) && ((cc=mlHandleMouse(buf,nbuf,compOff)) != 0))
            {
                ipos = ilen = strlen(buf) ;
                if(cc == 2)
                    cont_flag = 0;
            }
        }
        else
        {
            unsigned int arg ;
            short idx ;
            int ff ;
            
            idx = decode_key((unsigned short) cc,&arg) ;
            if(arg)
            {
                ff = 1 ;
                ii = (int) (arg + 0x80000000) ;
            }
            else
            {
                ff = 0 ;
                ii = 1 ;
            }
            switch(idx)
            {
            case CK_GOBOL:          /* ^A : Move to start of buffer */
                if(mlStatus & MLSTATUS_NINPUT)
                {
                    while(ipos && (buf[ipos-1] != meNLCHAR))
                        ipos-- ;
                }
                else
                    ipos = 0;
                break;
                
            case CK_BAKCHR:    /* ^B : Backwards char */
                while(ipos && ii--)
                    ipos--;
                break;
                
            case CK_DELFOR:    /* ^D : Delete the character under the cursor */
                while((ipos < ilen) && ii--)
                {
                    cdel(buf, ipos, &ilen);
                    /*                if(ipos > ilen)*/
                    /*                    ipos = ilen;*/
                    changed=1 ;
                }
                break;
                
            case CK_GOEOL:    /* ^E : Move to end of buffer */
                if(mlStatus & MLSTATUS_NINPUT)
                {
                    while((ipos < ilen) && (buf[ipos] != meNLCHAR))
                        ipos++ ;
                }
                else
                    ipos = ilen ;
                break;
                
            case CK_FORCHR:    /* ^F : Move forward one character */
                while((ipos < ilen) && ii--)
                    ipos++;
                break;
                
            case CK_ABTCMD: /* ^G : Abort input and return */
                mlfreeList(option,noStrs,strList) ;
                return ctrlg(FALSE,1);
                
            case CK_DELBAK:    /* ^H : backwards delete. */
                while(ipos && ii--)
                {
                    cdel(buf, ipos-1, &ilen);
                    ipos--;
                    changed=1 ;
                }
                break;
                
            case CK_DOTAB:    /* ^I : Tab character */
                if(mlStatus & MLSTATUS_NINPUT)
                {
                    cont_flag = 0;
                    break;
                }
                cc = '\t' ;    /* ^I for search strings */
                if(!(option & (MLCOMMAND | MLFILE | MLBUFFER | MLVARBL | MLUSER)))
                    goto input_addexpand ;
input_expand:
                if(option & MLFILE)
                {
                    char fname[FILEBUF], *base ;
                    
                    pathNameCorrect(buf,fname,&base) ;
                    strcpy(buf,fname) ;
                    ipos = ilen = strlen(buf) ;
                    /* if current buff is xxx/yyy/ then pathNameCorrect will
                     * return the path as xxx/ and base as yyy/ but for completion
                     * we want to list yyy/ so move the base for the case */
                    if(buf[ilen-1] != DIR_CHAR)
                        *base = '\0' ;
                    compOff = strlen(fname) ;
                    getDirectoryList(fname,&curDirList) ;
                    noStrs = curDirList.size ;
                    strList = curDirList.list ;
                }
                if(strList == NULL)
                {
                    contstr = compNoExp ;
                    TTbell();
                    break ;
                }
                if(changed)
                {
                    changed = 0 ;
                    if((gotPos = getFirstLastPos
                        (noStrs,strList,buf+compOff,option,&fstPos,&lstPos)) == 0)
                    {
                        contstr = compNoMch ;
                        TTbell();
                        break ;
                    }
                    curPos = fstPos-1 ;
                    if(fstPos == lstPos)
                    {
                        strcpy(buf+compOff,(strList[lstPos])) ;
                        ilen += strlen(buf+ilen) ;
                        if((option & MLFILE) && (buf[ilen-1] == DIR_CHAR))
                            /* if we're entering a file name and we've just
                             * completed to the a directory name then the next
                             * 'TAB' completion should be for inside the new directory,
                             * so effectively we have changed the input point */
                            changed = 1 ;
                    }
                    else
                    {
                        for(ii=fstPos ; ii<=lstPos ; ii++)
                            if(strList[ii][ilen-compOff] == cc)
                                goto input_addexpand ;
                        for(;;)
                        {
                            ch = strList[lstPos][ilen-compOff] ;
                            for(ii=fstPos ; ii<lstPos ; ii++)
                                if((strList[ii][ilen-compOff] != ch) &&
                                   (((option & MLINSENSCASE) == 0) ||
                                    ((char) toLower(strList[ii][ilen-compOff]) != (char) toLower(ch))))
                                    break ;
                            if(ii != lstPos)
                                break ;
                            if(ch == '\0')
                                break ;
                            buf[ilen++] = ch ;
                        }
                        buf[ilen] = '\0' ;
                    }
                    ipos = ilen ;
                }
                else if(!gotPos)
                    contstr = compNoMch ;
                else if(fstPos == lstPos)
                    contstr = compSole ;
                else
                {
                    char line[150] ;
                    int  len, lwidth ;
                    
                    for(ii=fstPos ; ii<=lstPos ; ii++)
                        if(strList[ii][ilen-compOff] == cc)
                            goto input_addexpand ;
                    if(mlgsOldCwp == NULL)
                    {
                        if(wheadp->w_wndp == NULL)
                            mlgsSingWind = 1 ;
                        else
                            mlgsSingWind = 0 ;
                        mlgsOldCwp = curwp ;
                    }
                    
                    if(wpopup(BcompleteN,BFND_CREAT|BFND_CLEAR|WPOP_MKCURR) == NULL)
                    {
                        contstr = compFailComp ;
                        break ;
                    }
                    /* Compute the widths available from the window width */
                    lwidth = curwp->numTxtCols >> 1;
                    if (lwidth > 75)
                        lwidth = 75 ;
                    curwp->w_marko = lwidth ;
                    for(ii=fstPos ; ii<=lstPos ; ii++)
                    {
                        unsigned char flag ;
                        
                        if(((len= strlen(strList[ii])) < lwidth) && (ii<lstPos) &&
                           (strlen(strList[ii+1]) < lwidth-1))
                        {
                            strcpy(line,strList[ii++]) ;
                            memset(line+len,' ',lwidth-len) ;
                            strcpy(line+lwidth,strList[ii]) ;
                            flag = LNNEOL ;
                        }
                        else
                        {
                            strncpy(line,strList[ii],148) ;
                            line[149] = '\0' ;
                            flag = 0 ;
                        }
                        addLineToEob(curbp,line) ;
                        curbp->b_linep->l_bp->l_flag |= flag ;
                    }
                    gotobob(FALSE,FALSE) ;
                    update(TRUE) ;
                }
                break ;
                
            case CK_MOVUWND:
                if(mlgsOldCwp != NULL)
                {
                    scrollUp(ff,ii) ;
                    update(TRUE) ;
                }
                break ;
                
            case CK_MOVDWND:
                if(mlgsOldCwp != NULL)
                {
                    scrollDown(ff,ii) ;
                    update(TRUE) ;
                }
                break ;
                
            case CK_BAKLIN: /* M-P - previous match in complete list */
                if(mlStatus & MLSTATUS_NINPUT)
                {
                    ii = ipos ;
                    while(ii && (buf[ii] != meNLCHAR))
                        ii-- ;
                    if(ii)
                    {
                        int jj ;
                        jj = ipos - ii ;
                        ipos = ii ;
                        while(ii-- && (buf[ii] != meNLCHAR))
                            ;
                        if((ii+jj) < ipos)
                            ipos = ii+jj ;
                    }
                }
                else
                {
                    if(ff || !(option & (MLCOMMAND | MLFILE | MLBUFFER | MLVARBL | MLUSER)))
                        goto mlgs_prevhist ;
                    if((strList != NULL) && !changed && gotPos)
                    {
                        if(fstPos == lstPos)
                            contstr = compSole ;
                        else
                        {
                            if(--curPos < fstPos)
                                curPos = lstPos ;
                            strncpy(buf+compOff,strList[curPos],nbuf-compOff) ;
                            buf[nbuf-1] = '\0' ;
                            ipos = ilen = strlen(buf) ;
                        }
                    }
                }
                break ;
                
            case CK_FORLIN: /* ^N - next match in complete list */
                if(mlStatus & MLSTATUS_NINPUT)
                {
                    ii = ipos ;
                    while((ii < ilen) && (buf[ii] != meNLCHAR))
                        ii++ ;
                    if(ii < ilen)
                    {
                        int jj ;
                        jj = ipos ;
                        while(jj-- && (buf[jj] != meNLCHAR))
                            ;
                        jj = ipos-jj-1 ;
                        ipos = ii+1 ;
                        while((--jj >= 0) && (ipos < ilen) && (buf[ipos] != meNLCHAR))
                            ipos++ ;
                    }
                }
                else
                {
                    if(ff || !(option & (MLCOMMAND | MLFILE | MLBUFFER | MLVARBL | MLUSER)))
                        goto mlgs_nexthist ;
                    if((strList != NULL) && !changed && gotPos)
                    {
                        if(fstPos == lstPos)
                            contstr = compSole ;
                        else
                        {
                            if(++curPos > lstPos)
                                curPos = fstPos ;
                            strncpy(buf+compOff,strList[curPos],nbuf-compOff) ;
                            buf[nbuf-1] = '\0' ;
                            ipos = ilen = strlen(buf) ;
                        }
                    }
                }
                break ;
                
            case CK_KILEOL:    /* ^K : Kill to end of line */
                if(ipos < ilen)
                {
                    if(mlStatus & MLSTATUS_NINPUT)
                    {
                        ii = ilen ;
                        while((ipos < ilen) && (buf[ipos] != meNLCHAR))
                            cdel(buf, ipos, &ilen);
                        if((ii==ilen) ||
                           (!meModeTest(globMode,MDLINE) &&         /* if line kill mode    */
                            (ipos < ilen) &&                        /* some chars left      */
                            (!ipos || (buf[ipos-1] == meNLCHAR))))  /* whole line           */
                            cdel(buf, ipos, &ilen);
                    }
                    else
                    {
                        buf[ipos] = '\0';
                        ilen = ipos;
                    }
                    changed=1 ;
                }
                break;
                
            case CK_RECENT:  /* ^L : Redraw the screen */
                sgarbf = TRUE;
                update(TRUE) ;
                mlerase(0);
                break;
                
            case CK_NEWLIN:  /* ^J : New line. Finish processing */
                if(mlStatus & MLSTATUS_NINPUT)
                {
                    cc = meNLCHAR ;
                    goto input_addexpand ;
                }
                cont_flag = 0;
                break;
                
            case CK_GOEOP:    /* M-N : Got to next in history list */
                /* Note the history list is reversed, ie 0 most recent,
                ** (numHist-1) the oldest. However if numHist then its
                ** the current one (wierd but easiest to implement
                */
mlgs_nexthist:
                if(!(option & MLNOHIST) && (numHist > 0))
                {
                    if(onHist > numHist)
                        /* if on current then save */
                        strcpy(mlgsStoreBuf,buf) ;
                    if(onHist == 0)
                    {
                        onHist = numHist+1 ;
                        strcpy(buf,mlgsStoreBuf) ;
                    }
                    else if(onHist > numHist)
                    {
                        strcpy(prom+strlen(prompt),": ") ;
                        defaultStr = NULL ;
                        onHist = numHist ;
                        buf[0] = '\0' ;
                    }
                    else
                    {
                        strncpy(buf,history[--onHist],nbuf) ;
                        buf[nbuf-1] = '\0' ;
                    }                    
                    ipos = ilen = strlen(buf) ;
                    changed=1 ;
                }
                break;
                
            case CK_GOBOP:    /* M-P : Got to previous in history list */
mlgs_prevhist:
                if(!(option & MLNOHIST) && (numHist > 0))
                {
                    if(onHist > numHist)
                    {
                        /* if on current then save */
                        strcpy(mlgsStoreBuf,buf) ;
                        onHist = 0 ;
                    }
                    else
                        ++onHist ;
                    if(onHist > numHist)
                        strcpy(buf,mlgsStoreBuf) ;
                    else if(onHist == numHist)
                    {
                        strcpy(prom+strlen(prompt),": ") ;
                        defaultStr = NULL ;
                        buf[0] = '\0' ;
                    }
                    else
                    {
                        strncpy(buf,history[onHist],nbuf) ;
                        buf[nbuf-1] = '\0' ;
                    }
                    ipos = ilen = strlen(buf) ;
                    changed=1 ;
                }
                break;
                
            case CK_TRNCHR:
                /* ^T : Transpose the character before the cursor
                 *      with the one under the cursor.
                 */
                if(ipos && ipos < ilen)
                {
                    cc = buf[ipos - 1];
                    buf[ipos - 1] = buf[ipos];
                    buf[ipos] = cc;
                    changed=1 ;
                }
                break;
                
            case CK_KILREG:    /* ^W : Kill the whole line */
                ipos = 0 ;
                ilen = 0 ;
                buf[ipos] = '\0';
                changed=1 ;
                break;
            case CK_QUOTE:    /* ^Q - quote the next character */
                if((cc = quoteKeyToChar(tgetc())) < 0)
                {
                    TTbell() ;
                    break ;
                }
                while(ii--)
                    if(cins((char) cc, buf, &ipos, &ilen, nbuf) == FALSE)
                        TTbell();
                changed=1 ;
                break;
                
            case CK_OPNLIN:    /* ^O : Insert current line into buffer */
                {
                    register char *p = (char *) curwp->w_dotp->l_text;
                    register int   count = curwp->w_dotp->l_used;
                    
                    while(*p && count--)
                        cins(*p++, buf, &ipos, &ilen, nbuf);
                    changed=1 ;
                    break ;
                }
            case CK_YANK:    /* ^Y : insert yank buffer */
                {
                    register char *pp, cy ;
                    KILL          *killp;
                    
#ifdef _CLIPBRD
                    if((clipState & CLIP_TRY_GET) || (kbdmode != PLAY))
                        TTgetClipboard() ;
#endif
                    if(klhead == (KLIST*) NULL)
                    {
                        TTbell() ;
                        break ;
                    }
                    killp = klhead->kill;
                    
                    while(killp != NULL)
                    {
                        pp = (char *) killp->data ;
                        while((cy=*pp++))
                            if(cins(cy, buf, &ipos, &ilen, nbuf) == FALSE)
                            {
                                TTbell() ;
                                break ;
                            }
                        killp = killp->next;
                    }
                    changed=1 ;
                    break;
                }
                
            case CK_INSFLNM:    /* insert file name */
                {
                    register char ch, *p = curbp->b_fname;
                    
                    if(p != NULL)
                        while(ii--)
                            while((ch=*p++) && cins(ch, buf, &ipos, &ilen, nbuf))
                                ;
                    break ;
                }
                
                /*
                 * Handle a limited set of Meta sequences. Note that
                 * there is no conflict when the end-of-line char is
                 * escape, since we will never reach here if it is.
                 */
            case CK_BAKWRD:    /* M-B : Move to start of previous word */
                while(ipos && ii--)
                {
                    bspace(buf, &ipos, &ilen, LEAVE); /* move over space after word */
                    bword(buf, &ipos, &ilen, LEAVE);  /* move over word */
                }
                break;
                
            case CK_CAPWRD:    /* M-C : Capitalise next word and move past it. */
                while(ilen && (ipos != ilen) && ii--)
                {
                    fspace(buf, &ipos, &ilen, LEAVE); /* Move over spaces before word */
                    /* capitalise if lower-case letter */
                    buf[ipos] = toUpper(buf[ipos]) ;
                    for(ipos++ ; (ipos<ilen) && isWord(buf[ipos]) ; ipos++)
                        buf[ipos] = toLower(buf[ipos]) ;
                    changed=1 ;
                }
                break;
                
            case CK_HIWRD:    /* M-U : Capitalise the whole of the next
                               *      word and move past it.
                               */
                while(ii--)
                {
                    /* move over spaces before word */
                    fspace(buf, &ipos, &ilen, LEAVE);
                    
                    /* capitalise if lower-case letter */
                    for(; (ipos<ilen) && isWord(buf[ipos]) ; ipos++)
                        buf[ipos] = toUpper(buf[ipos]) ;
                    changed=1 ;
                }
                break;
                
            case CK_LOWWRD:   /* M-L : Converts to lower case the whole of the next
                               *      word and move past it.
                               */
                while(ii--)
                {
                    /* move over spaces before word */
                    fspace(buf, &ipos, &ilen, LEAVE);
                    
                    /* to lower-case letter */
                    for(; (ipos<ilen) && isWord(buf[ipos]) ; ipos++)
                        buf[ipos] = toLower(buf[ipos]) ;
                    changed=1 ;
                }
                break;
                
            case CK_DELFWRD: /* Delete word forwards. */
                while(ilen && ii--)
                {
                    fspace(buf, &ipos, &ilen, ERASE);    /* eat spaces before word */
                    fword(buf, &ipos, &ilen, ERASE);    /* eat word */
                    changed=1 ;
                }
                break;
                
            case CK_FORWRD:    /* M-F : Move forward to start of next word. */
                while((ipos != ilen) && ii--)
                {
                    /* move over spaces before word */
                    fspace(buf, &ipos, &ilen, LEAVE);
                    fword(buf, &ipos, &ilen, LEAVE);    /* move over word */
                }
                break;
                
            case CK_SETMRK:
                /*
                 * Do nothing - one day this will set the
                 * mark at the current cursor position.
                 */
                TTbell();
                break;
                
            case CK_DELWBAK:
                /* Delete word backwards. If spaces before
                 * the input position then delete those too.
                 */
                while(ipos && ii--)
                {
                    bspace(buf, &ipos, &ilen, ERASE);    /* eat spaces after word */
                    bword(buf, &ipos, &ilen, ERASE);    /* eat word */
                    changed=1 ;
                }
                break;
                
            case CK_REYANK:    /* M-Y or M-^Y : Yank the current buffername. */
                {
                    register char*  p = curbp->b_bname;
                    
                    while(*p && cins(*p++, buf, &ipos, &ilen, nbuf))
                        ;
                    changed=1 ;
                    break;
                }
                
            case CK_FISRCH:
            case CK_FORSRCH:
            case CK_BISRCH:
            case CK_BAKSRCH:
                if(option & MLISEARCH)
                {
                    mlfirst = cc ;
                    mlfreeList(option,noStrs,strList) ;
                    return TRUE ;
                }
                TTbell() ;
                break ;
                
            case CK_VOIDFUNC:
                break ;
                
            case -1:
                if(cc & 0xff00)    /* if control, meta or prefix then scrap */
                {
                    TTbell();
                    break ;
                }
                
                if (cc == ' ')    /* space */
                {
                    if(option & (MLCOMMAND | MLFILE | MLBUFFER | MLVARBL | MLUSER))
                        goto input_expand ;
                    if(option & MLNOSPACE)
                    {
                        TTbell() ;
                        break ;
                    }
                }
input_addexpand:
                /* Else ordinary letter to be stored */
                
                if(option&MLUPPER && cc >= 'a' && cc <= 'z')
                    cc -= 'a' - 'A';
                else if(option&MLLOWER && cc >= 'A' && cc <= 'Z')
                    cc += 'a' - 'A';
                /*
                 * And insert it ....
                 */
                if(cins((char) cc, buf, &ipos, &ilen, nbuf) == FALSE)
                    TTbell();
                changed=1 ;
                break;
                
            default:
                TTbell();
            }
        }
    }

    /*---    Terminate the input. */
    if(ilen == 0)
    {
        if(defaultStr != NULL)
        {
            strncpy(buf,defaultStr,nbuf) ;
            buf[nbuf-1] = '\0' ;
        }
    }
    
    /* Store the history if it is not disabled. */
    if((option & (MLNOHIST|MLNOSTORE)) == 0)
    {
        char *ss=mlgsStoreBuf ;
        
        /* If the number of history buffers is at it's maximum 
         * then swap out the last history buffer (mlgsStoreBuf is
         * deleted soon), otherwise the slot will be NULL and
         * nothing will get freed
         */
        mlgsStoreBuf = history[MLHISTSIZE-1] ;
        strcpy(ss,buf) ;
        if(numHist < MLHISTSIZE)
        {
            numHist++ ;
            (*numPtr)++ ;
        }
        for(ii=numHist-1 ; ii>0 ; ii--)
            history[ii] = history[ii-1] ;
        history[0] = ss ;
    }
    mlfreeList(option,noStrs,strList) ;

    return(TRUE);
}

