#____________________________________________________________________________
#
# Make file for MicroEmacs using Borland C++ Builder 3
# 
# Author      : Steven Phillips
# Last Edited : <990617.0904>
#
# Details     : 
#               Build from the command line using nmake. 
#
#               make              - builds locally.
#		make clean        - cleans emacs directory
#		make spotless     - cleans some more !!
#		make install	   - builds and copies to c:\emacs.
#____________________________________________________________________________
# Uncomment the next line for no console support
SUPSYS	= -aa  $(LIBRARY)\c0w32.obj
# Uncomment the next 2 lines for console support
#CONDEF	= -D_WINCON
#SUPSYS	= -ap  $(LIBRARY)\c0x32.obj
#
# Uncomment the next 2 lines for URL support
#URLDEF	= -D_URLSUPP
#URLLIB	= $(LIBRARY)\ws2_32.lib
#
#
# TOOLS Environment - change to location of your tools.
#
TOOLSDIR=       c:\progra~1\borland\cbuild~1
INCLUDE=	$(TOOLSDIR)\include
LIBRARY=	$(TOOLSDIR)\lib

#
# Destination directory.
#
BINDIR	=	c:\emacs
#
# CTYPE - pick optimised or debugged.
CTYPE	= $(COPTIMISE)
#CTYPE	= $(CDEBUG)

#
# Standard Compilation tools and flags
#
CC	=	bcc32
RC	=	brc32
RM	=	erase
LD	=	tlink32
INSTALL	=	copy
MKDIR	=	mkdir

# Standard File Extensions
I	=	-I
O	=	.obj
EXE	=	.exe

# Extended build rules.
.SUFFIXES: .c .obj
.c.obj:
	$(CC) $(CFLAGS) -c $< -o$*$(O)

#
# Standard include stuff
#
CDEBUG		=	-N -v
CPROFILE	=	-N -v
COPTIMISE	=	-N -O2
CNONOPTIMISE	=	-N -O2

LDFLAGS		=	-v

CINCLUDES	=	$(I). $(I)$(INCLUDE)
CFLAGS		=	$(CINCLUDES) $(CTYPE) -w-par -D_JASSPA_ME -D_WIN32 -DWIN32 $(CONDEF) $(URLDEF) -D_WINDOWS -D_MBCS
LDFLAGS		=	$(LDFLAGS) -L$(LIBRARY) -Tpe -x -v $(SUPSYS)

SYSLIBS         =	$(URLLIB)		\
			import32.lib cw32mt.lib



# Note that oldnames.lib is MSCV 2.0 NOT 4.0

#
# Define the files involved in the build.
#
HEADERS = ebind.h edef.h eextrn.h efunc.h esearch.h estruct.h evar.h \
	  evers.h eterm.h ebind.def efunc.def evar.def emain.h eprint.h
PLTHDR  = wintermr.h
STDSRC	= abbrev.c basic.c bind.c buffer.c crypt.c dirlist.c display.c \
	  eval.c exec.c file.c fileio.c hilight.c history.c input.c \
	  isearch.c key.c line.c macro.c main.c narrow.c next.c osd.c \
	  print.c registry.c random.c region.c search.c spawn.c spell.c \
	  tag.c termio.c time.c undo.c window.c word.c regex.c
PLTSRC  = winterm.c winprint.c

STDOBJ	= $(STDSRC:.c=.obj)
PLTOBJ  = $(PLTSRC:.c=.obj)
OBJ	= $(STDOBJ) $(PLTOBJ)

#
# Standard build rules
#
all::	me32$(EXE)

me32$(EXE): $(OBJ) me.res
	$(LD) $(LDFLAGS) $(OBJ), me32.exe,, $(SYSLIBS),, me.res

$(STDOBJ): $(HEADERS)
$(PLTOBJ): $(HEADERS) $(PLTHDR)

me.res: me.rc
	$(RC) -v -i . -i $(INCLUDE) -i $(INCLUDE)\mfc -fo $@ me.rc 

relink::
	$(RM)	me32$(EXE)
	$(MAKE) -f $(MAKEFILE) $(MFLAGS) me32$(EXE)

install:: me32$(EXE)
	$(INSTALL) me32$(EXE) $(BINDIR)
	@echo Install done.

spotless:: clean
	$(RM) *.??~
clean::
	- $(RM) *.pch
	- $(RM) *.o
	- $(RM) *.exe
	- $(RM) *.res
